package com.ridgesoft.robotics;

/**
 * Generic interface to an object that supports receiving data 
 * from an infrared remote control. 
 */
public interface IrRemote {
  
  /**
   * Reads the next value received from the remote control 
   * or returns -1 if no character has been received 
   * since the last read. 
   * @return Value received from the remote control or -1 if no data has been received
   */
  public int read();
}